% Simulation program to realize PTS with V=4  to reduct PAPR of SISO-OFDM

clc;
clear;
close all;
%************************ preparation part *****************************
para=256;     % Number of parallel channel to transmit (points)
fftlen=256;   % FFT length
nloop=1000;  % Number of simulation loops
level=2;                                        % Level modulasi : 1.BPSK 2.QPSK 3.8-PSK

%************************** main loop part **************************
for iii=1:nloop
    
    %************************** Data generation **************************
    % Pengacakan bit
    X_info = randint(1,para,2^level);                        %
    seldata = pskmod(X_info,2^level);                            % PSK modulation
    %******************************** IFFT ********************************
    y=ifft(seldata);
  
    %************************* Sub-block Partition ***************************
    V=4;
    seldata40=zeros(1,para/4);
    seldata41=[seldata(1:para/4),seldata40,seldata40,seldata40];
    seldata42=[seldata40,seldata(para/4+1:para/2),seldata40,seldata40];
    seldata43=[seldata40,seldata40,seldata(para/2+1:3*para/4),seldata40];
    seldata44=[seldata40,seldata40,seldata40,seldata(3*para/4+1:para)];
    %************************** Ifft*******************************
    y41=ifft(seldata41);                 %  ifft : built in function
    y42=ifft(seldata42);
    y43=ifft(seldata43);
    y44=ifft(seldata44);
    Vloop=2.^V;
    B4=zeros(Vloop,V);
    for vvv=1:1:Vloop
        B4(vvv,:)=2*(rand(1,V)>0.5)-1 ;
        ypts=B4(vvv,1)*y41+B4(vvv,2)*y42+B4(vvv,3)*y43+B4(vvv,4)*y44;
        mma4(vvv)=max(abs(ypts).^2);
    end
    [mmioa4,idx4]=min(mma4);
    b4=B4(idx4,:);
    b4
    yptsV4=b4(1)*y41+b4(2)*y42+b4(3)*y43+b4(4)*y44;
    
    pr(iii)=papr(y);
    pr2(iii)=papr(yptsV4);
end
Pprr=ccdf(pr);
Pprr2=ccdf(pr2);

papr0_in_dB=2.001:0.001:14;
figure(20);
semilogy(papr0_in_dB,Pprr);hold on;
semilogy(papr0_in_dB,Pprr2,'g--');
hold off;
axis([2 14  1e-003 1e000]) ;
ylabel('Pr(PAPR>PAPR0)');
xlabel('PAPR0/dB');
title('performance' );
legend('primary OFDM','PTS V=4');
grid on;
